namespace AOC2022.Puzzles;

internal class Day3 : IPuzzle
{
	private readonly string[] _linesFromFile;
	private readonly int noOfRuckSacks;

	public Day3(string[] linesFromFile)
	{
		_linesFromFile = linesFromFile;
		noOfRuckSacks = linesFromFile.Length;
	}
	public void FirstPuzzle()
	{
		var leftComparments = new string[noOfRuckSacks];
		var rightCompartments = new string[noOfRuckSacks];
		var index = 0;
		foreach (var line in _linesFromFile)
		{
			var ruckSack = line.Trim();
			var left = ruckSack[..(ruckSack.Length / 2)];
			var right = ruckSack[(ruckSack.Length / 2)..];
			leftComparments[index] = left;
			rightCompartments[index] = right;
			index++;
		}
		var prioritySum = 0;
		for (int i = 0; i < noOfRuckSacks; i++)
		{
			char duplicateItem = ' ';
			foreach (var item in leftComparments[i])
			{
				if (rightCompartments[i].Contains(item))
				{
					duplicateItem = item;
					break;
				}
			}
			prioritySum += EvaluatePriority(duplicateItem);
		}
		Console.WriteLine($"Priority sum of duplicate items in compartments: {prioritySum}");
	}

	public void SecondPuzzle()
	{
		var prioritySum = 0;
		for (int i = 0; i < noOfRuckSacks; i += 3)
		{
			var elf1Sack = _linesFromFile[i].Trim();
			var elf2Sack = _linesFromFile[i + 1].Trim();
			var elf3Sack = _linesFromFile[i + 2].Trim();
			char authenticItem = ' ';
			foreach (var item in elf1Sack)
			{
				if (elf2Sack.Contains(item) && elf3Sack.Contains(item))
				{
					authenticItem = item;
					break;
				}
			}
			prioritySum += EvaluatePriority(authenticItem);
		}
		Console.WriteLine($"Priority sum of authentic items groups of 3 elves: {prioritySum}");
	}

	private static int EvaluatePriority(char ruckSackItem)
	{
		if (char.IsUpper(ruckSackItem))
		{
			return (ruckSackItem - 'A') + 27;
		}
		else if (char.IsLower(ruckSackItem))
		{
			return (ruckSackItem - 'a') + 1;
		}
		else
		{
			return 0;
		}
	}
}
